// C++/WinRT v2.0.250303.1

// SPDX-License-Identifier: MIT OR Apache-2.0
// SPDX-FileCopyrightText: Copyright (c) Microsoft Corporation
//
// Generated using .winmd files from https://github.com/microsoft/windows-rs
//

#pragma once
#ifndef WINRT_Windows_UI_Notifications_Preview_H
#define WINRT_Windows_UI_Notifications_Preview_H
#include "winrt/base.h"
static_assert(winrt::check_version(CPPWINRT_VERSION, "2.0.250303.1"), "Mismatched C++/WinRT headers.");
#define CPPWINRT_VERSION "2.0.250303.1"
#include "winrt/Windows.UI.Notifications.h"
#include "winrt/impl/Windows.UI.2.h"
#include "winrt/impl/Windows.UI.Notifications.Preview.2.h"
namespace winrt::impl
{
    template <typename D> auto consume_Windows_UI_Notifications_Preview_IToastOcclusionManagerPreviewStatics<D>::SetToastWindowMargin(winrt::Windows::UI::WindowId const& appWindowId, double margin) const
    {
        if constexpr (!std::is_same_v<D, winrt::Windows::UI::Notifications::Preview::IToastOcclusionManagerPreviewStatics>)
        {
            winrt::hresult _winrt_cast_result_code;
            auto const _winrt_casted_result = impl::try_as_with_reason<winrt::Windows::UI::Notifications::Preview::IToastOcclusionManagerPreviewStatics, D const*>(static_cast<D const*>(this), _winrt_cast_result_code);
            check_hresult(_winrt_cast_result_code);
            auto const _winrt_abi_type = *(abi_t<winrt::Windows::UI::Notifications::Preview::IToastOcclusionManagerPreviewStatics>**)&_winrt_casted_result;
            check_hresult(_winrt_abi_type->SetToastWindowMargin(impl::bind_in(appWindowId), margin));
        }
        else
        {
            auto const _winrt_abi_type = *(abi_t<winrt::Windows::UI::Notifications::Preview::IToastOcclusionManagerPreviewStatics>**)this;
            check_hresult(_winrt_abi_type->SetToastWindowMargin(impl::bind_in(appWindowId), margin));
        }
    }
#ifndef WINRT_LEAN_AND_MEAN
    template <typename D>
    struct produce<D, winrt::Windows::UI::Notifications::Preview::IToastOcclusionManagerPreviewStatics> : produce_base<D, winrt::Windows::UI::Notifications::Preview::IToastOcclusionManagerPreviewStatics>
    {
        int32_t __stdcall SetToastWindowMargin(struct struct_Windows_UI_WindowId appWindowId, double margin) noexcept final try
        {
            typename D::abi_guard guard(this->shim());
            this->shim().SetToastWindowMargin(*reinterpret_cast<winrt::Windows::UI::WindowId const*>(&appWindowId), margin);
            return 0;
        }
        catch (...) { return to_hresult(); }
    };
#endif
}
WINRT_EXPORT namespace winrt::Windows::UI::Notifications::Preview
{
    inline auto ToastOcclusionManagerPreview::SetToastWindowMargin(winrt::Windows::UI::WindowId const& appWindowId, double margin)
    {
        impl::call_factory<ToastOcclusionManagerPreview, IToastOcclusionManagerPreviewStatics>([&](IToastOcclusionManagerPreviewStatics const& f) { return f.SetToastWindowMargin(appWindowId, margin); });
    }
}
namespace std
{
#ifndef WINRT_LEAN_AND_MEAN
    template<> struct hash<winrt::Windows::UI::Notifications::Preview::IToastOcclusionManagerPreviewStatics> : winrt::impl::hash_base {};
    template<> struct hash<winrt::Windows::UI::Notifications::Preview::ToastOcclusionManagerPreview> : winrt::impl::hash_base {};
#endif
#ifdef __cpp_lib_format
#endif
}
#endif
